;*** Visokofrekvencni DDS signal generator - S53MV 20.07.2008 ***

;*** Vhodno/izhodni prikljucki LPC2138/2148 @60MHz (kristal=12MHz) ***
;P0.0-7 - digitalni izhodi za LCD HD44780 D0-7
;P0.8-9 - UART1 (neuporabljeno)
;P0.10-13 - digitalni izhodi (neuporabljeno)
;P0.14 - digitalni vhod /bootloader, pullup na +3.3V 
;P0.15-16 - digitalni izhodi (neuporabljeno)
;P0.17 - digitalni izhod /W_CLK za AD9851
;P0.18 - digitalni izhod /FQ_UD za AD9851
;P0.17 - digitalni izhod D7 za AD9851
;P0.20 - digitalni izhod /RESET za AD9851
;P0.21-23 - digitalni izhodi (neuporabljeno)
;P0.25 - analogni izhod AOUT - AM za AD9851
;P0.26-27 - USB? (neuporabljeno)
;P0.28 - digitalni izhod (neuporabljeno)
;P0.29 - digitalni izhod za LCD HD44780 RS
;P0.30 - digitalni izhod za LCD HD44780 E
;P0.31 - digitalni izhod (neuporabljeno)
;P1.16 - digitalni vhod - tipka DESNO
;P1.17 - digitalni vhod - tipka DOL
;P1.18 - digitalni vhod - tipka GOR
;P1.19 - digitalni vhod - tipka LEVO
;P1.20-25 - digitalni vhodi (neuporabljeno)
;P1.26 - JTAG vhod/izhod RTCK
;P1.27 - JTAG izhod TDO
;P1.28 - JTAG vhod TDI
;P1.29 - JTAG vhod TCK
;P1.30 - JTAG vhod TMS
;P1.31 - JTAG vhod TRST

;*** Ukazi za delovanje zbirnika ARM ***
        AREA	RESET, CODE, READONLY, ALIGN=9
	ENTRY
	CODE32

;*** Konstante programa ***
ZMIGA	EQU	0x40		;perioda utripanja (mora biti 2^N)
TPREKIN EQU	150		;perioda stevca prekinitev /15MHz

;*** Dodelitev pomnilnika RAM ***
SKLAD	EQU	0x40000480	;glavni sklad (navzdol ???)
ISKLAD	EQU	0x400004F0	;prekinitveni sklad (navzdol ???)
ZASLON	EQU	0x40000500	;vsebina zaslona (32 bajtov)

ZNACKA	EQU	0x40000580	;znacka na zaslonu
UTRIP	EQU	0x40000584	;stevec utripanja
KAZALO	EQU	0x40000588	;kazalec na velicino
TIPKES	EQU	0x4000058C	;stare tipke
PREMIK	EQU	0x40000590	;premik parametra
RFREQ	EQU	0x40000594	;preracunana frekvenca nosilca
RCWJAK	EQU	0x40000598	;jakost CW
FMINC	EQU	0x4000059C	;FM tonska konstanta
FMOSC	EQU	0x400005A0	;FM tonski oscilator
FMDEV	EQU	0x400005A4	;FM koleb
AMINC	EQU	0x400005A8	;AM tonska konstanta
AMOSC	EQU	0x400005AC	;AM tonski oscilator
AMMOD	EQU	0x400005B0	;AM globina modulacije
INC30	EQU	0x400005B4	;VOR frekvenca 30Hz
OSC30	EQU	0x400005B8	;VOR oscilator 30Hz
PHI30	EQU	0x400005BC	;VOR faza 30Hz
VORMOD	EQU	0x400005C0	;VOR globina 30Hz
VORDEV	EQU	0x400005C4	;VOR koleb podnosilca
INC9960 EQU	0x400005C8	;VOR frekvenca podnosilca
OSC9960 EQU	0x400005CC	;VOR oscilator 9960Hz
GLO150	EQU	0x400005D0	;ILS globina 150Hz
GLO90	EQU	0x400005D4	;ILS globina 90Hz

NACIN	EQU	0x40000600	;nacin modulacije
FREQ	EQU	0x40000604	;frekvenca
CWJAK	EQU	0x40000608	;jakost CW
KOLEB	EQU	0x4000060C	;koleb
FMTON	EQU	0x40000610	;modulacijski FM ton
AMGLO	EQU	0x40000614	;globina AM
AMTON	EQU	0x40000618	;modulacijski AM ton
VORGLO	EQU	0x4000061C	;globina VOR 30Hz
RADIAL	EQU	0x40000620	;VOR radial
ILSDDM	EQU	0x40000624	;ILS razlika globine
ILSGLO	EQU	0x40000628	;globina ILS 150Hz+90Hz
DDSCLK	EQU	0x4000062C	;referencni takt DDSja

IAPCMD	EQU	0x40000800	;ukaz IAP
IAPRES	EQU	0x40000880	;rezultat IAP

TNASLOV	EQU	0x40001000	;racunanje sinusne tabele (4096 bajtov)
SNASLOV	EQU	0x40002000	;sinusna tabela (8192 bajtov)

;*** Tabela izjem na zacetnem naslovu 0 ***
IZJEME	B	ZACNI
	B	IZJEME	;Undef
	B	IZJEME	;SWI
	B	IZJEME	;PAbt
	B	IZJEME	;DAbt
	NOP		;Reserved Vector
	B	PREKIN	;IRQ
	B	IZJEME	;FIQ
	ALIGN	512		;izbrisi naslov 0x00001FC

;*** Prekinitveni podprogram za TIMER0 v LPC2138/2148 *** (R0-3,R8)
PREKIN	STR	R0,[SP,#-4]!	;resi registre R0,R1,R2,R3
	STR	R1,[SP,#-4]!
	STR	R2,[SP,#-4]!
	STR	R3,[SP,#-4]!
	LDR	R0,=NACIN	;NACIN v R1
	LDR	R1,[R0]
	MOVS	R1,R1		;nacin CW?
	BNE	PREKIN1
PREKIN0	LDR	R0,=RCWJAK	;jakost CW nosilca
	LDR	R3,[R0]
	LDR	R0,=0xE006C000	;DACR
	STR	R3,[R0]
	B	PREKIN5
PREKIN1	SUBS	R1,R1,#1	;nacin FM?
	BNE	PREKIN2
	LDR	R0,=FMINC	;FM tonski oscilator R2
	LDR	R1,[R0]
	LDR	R0,=FMOSC
	LDR	R2,[R0]
	ADD	R2,R2,R1
	STR	R2,[R0]
	MOV	R2,R2,LSR#21	;sinusna tabela R1
	MOV	R2,R2,LSL#2
	LDR	R0,=SNASLOV
	LDR	R1,[R0,R2]
	LDR	R0,=FMDEV	;FM koleb
	LDR	R2,[R0]
	SMULL	R0,R3,R1,R2
	LDR	R0,=RFREQ	;pristej frekvenco nosilca
	LDR	R1,[R0]
	STR	R8,[SP,#-4]!
	STR	LR,[SP,#-4]!
	ADD	R8,R1,R3
	BL	FRQDDS		;postavi frekvenco DDS
	LDR	LR,[SP],#4
	LDR	R8,[SP],#4
	B	PREKIN5
PREKIN2	SUBS	R1,R1,#1	;nacin AM?
	BNE	PREKIN3
	LDR	R0,=AMINC	;AM tonski oscilator R2
	LDR	R1,[R0]
	LDR	R0,=AMOSC
	LDR	R2,[R0]
	ADD	R2,R2,R1
	STR	R2,[R0]
	MOV	R2,R2,LSR#21	;sinusna tabela R1
	MOV	R2,R2,LSL#2
	LDR	R0,=SNASLOV
	LDR	R1,[R0,R2]
	LDR	R0,=AMMOD	;AM globina
	LDR	R2,[R0]
	SMULL	R0,R3,R1,R2
	MOV	R3,R3,ASR#19
	MOV	R3,R3,LSL#6
	ADD	R3,R3,#0x8000	;odmik za nosilec
	LDR	R0,=0xE006C000	;DACR
	STR	R3,[R0]
	B	PREKIN5
PREKIN3	SUBS	R1,R1,#1	;nacin VOR?
	BNE	PREKIN4
	LDR	R0,=INC30	;VOR oscilator 30Hz
	LDR	R1,[R0]
	LDR	R0,=OSC30
	LDR	R2,[R0]
	ADD	R2,R2,R1
	STR	R2,[R0]
	LDR	R0,=PHI30	;odstej fazo 30Hz
	LDR	R1,[R0]
	SUB	R2,R2,R1
	MOV	R2,R2,LSR#21	;sinusna tabela R1
	MOV	R2,R2,LSL#2
	LDR	R0,=SNASLOV
	LDR	R1,[R0,R2]
	LDR	R0,=VORMOD	;globina 30Hz
	LDR	R2,[R0]
	SMULL	R0,R3,R1,R2
	STR	R3,[SP,#-4]!	;shrani modulacijo 30Hz
	LDR	R0,=OSC30	;referenca 30Hz
	LDR	R2,[R0]
	MOV	R2,R2,LSR#21	;sinusna tabela R1
	MOV	R2,R2,LSL#2
	LDR	R0,=SNASLOV
	LDR	R1,[R0,R2]
	LDR	R0,=VORDEV
	LDR	R2,[R0]
	SMULL	R0,R3,R1,R2
	LDR	R0,=INC9960
	LDR	R1,[R0]
	ADD	R1,R1,R3
	LDR	R0,=OSC9960	;oscilator FM podnosilca 9960Hz+/-480Hz
	LDR	R2,[R0]
	ADD	R2,R2,R1
	STR	R2,[R0]
	MOV	R2,R2,LSR#21	;sinusna tabela R1
	MOV	R2,R2,LSL#2
	LDR	R0,=SNASLOV
	LDR	R1,[R0,R2]
	LDR	R0,=VORMOD	;globina 9960Hz
	LDR	R2,[R0]
	SMULL	R0,R3,R1,R2
	LDR	R0,[SP],#4	;sestej modulaciji 30Hz in 9960Hz
	ADD	R3,R0,R3
	MOV	R3,R3,ASR#19
	MOV	R3,R3,LSL#6
	ADD	R3,R3,#0x8000	;odmik za nosilec
	LDR	R0,=0xE006C000	;DACR
	STR	R3,[R0]
	B	PREKIN5
PREKIN4 SUBS	R1,R1,#1	;nacin ILS?
	BNE	PREKIN0
	LDR	R0,=INC30	;oscilator 30Hz
	LDR	R1,[R0]
	LDR	R0,=OSC30
	LDR	R2,[R0]
	ADD	R2,R2,R1
	STR	R2,[R0]
	ADD	R2,R2,R2,LSL#2	;monozenje 30Hz*5=150Hz
	ADD	R2,R2,#0x40000000
	MOV	R2,R2,LSR#21	;sinusna tabela R1
	MOV	R2,R2,LSL#2
	LDR	R0,=SNASLOV
	LDR	R1,[R0,R2]
	LDR	R0,=GLO150	;globina 150Hz
	LDR	R2,[R0]
	SMULL	R0,R3,R1,R2
	STR	R3,[SP,#-4]!	;shrani modulacijo 150Hz
	LDR	R0,=OSC30	;mnozenje 30Hz*3=90Hz
	LDR	R2,[R0]
	ADD	R2,R2,R2,LSL#1
	ADD	R2,R2,#0x40000000
	MOV	R2,R2,LSR#21	;sinusna tabela R1
	MOV	R2,R2,LSL#2
	LDR	R0,=SNASLOV
	LDR	R1,[R0,R2]
	LDR	R0,=GLO90	;globina 90Hz
	LDR	R2,[R0]
	SMULL	R0,R3,R1,R2
	LDR	R0,[SP],#4	;sestej modulaciji 150Hz in 90Hz
	ADD	R3,R0,R3
	MOV	R3,R3,ASR#19
	MOV	R3,R3,LSL#6
	ADD	R3,R3,#0x8000	;odmik za nosilec
	LDR	R0,=0xE006C000	;DACR
	STR	R3,[R0]
PREKIN5	LDR	R0,=0xE0004000	;T0IR=0xFF reset zahtev TIMER0
	MOV	R1,#0xFF
	STRB	R1,[R0]
	LDR	R3,[SP],#4	;povrni registre R3,R2,R1,R0
	LDR	R2,[SP],#4
	LDR	R1,[SP],#4
	LDR	R0,[SP],#4
	SUBS	PC,LR,#4	;izhod iz prekinitve
	LTORG

;*** Preracunaj konstante za DSP *** (R0,R1,R2,R3,R4,R8)
RACUN	STR	LR,[SP,#-4]!	;resi link
	LDR	R1,=DDSCLK	;preracunaj DDS takt v periodo v R1
	LDR	R0,[R1]
	MOV	R1,#0
	MOV	R2,#0x80000000
RACUN1	ADD	R1,R1,R2
	UMULL	R3,R4,R0,R1
	CMP	R4,#0x01000000
	SUBCS	R1,R1,R2
	MOVS	R2,R2,LSR#1
	BNE	RACUN1
	STR	R1,[SP,#-4]!	;shrani periodo v sklad
	LDR	R0,=FREQ	;frekvenca nosilca
	LDR	R4,[R0]
	UMULL	R2,R3,R4,R1
	MOV	R8,R3,LSL#8
	ADD	R8,R8,R2,LSR#24
	LDR	R0,=RFREQ	;shrani preracunan nosilec
	STR	R8,[R0]
	LDR	R0,=NACIN	;preveri nacin
	LDR	R1,[R0]
	CMP	R1,#1
	BLNE	FRQDDS		;postavi frekvenco DDS razen 1=FM
	MOV	R3,#0x8000	;FM nosilec
	LDR	R0,=0xE006C000	;DACR
	STREQ	R3,[R0]		;jakost samo za 1=FM
	LDR	R0,=CWJAK	;CWJAK - konstanta za CW
	LDR	R1,[R0]
	LDR	R2,=67108
	MUL	R3,R1,R2
	MOV	R3,R3,LSR#17
	MOV	R3,R3,LSL#6
	LDR	R0,=RCWJAK	;jakost CW nosilca
	STR	R3,[R0]
	LDR	R0,=FMTON	;FMTON - konstante za FM
	LDR	R1,[R0]
	LDR	R3,=TPREKIN
	LDR	R4,=73301	;(2^40)/15MHz
	MUL	R2,R3,R4
	MOV	R2,R2,LSR#8
	MUL	R3,R1,R2
	LDR	R0,=FMINC	;FM tonska kontanta
	STR	R3,[R0]
	LDR	R0,[SP],#4	;upostevaj periodo DDSja za koleb
	MOV	R1,R0,LSR#20
	ADD	R2,R1,R0,LSR#22
	LDR	R0,=KOLEB	;KOLEB
	LDR	R1,[R0]
	MUL	R3,R1,R2
	LDR	R0,=FMDEV	;FM koleb
	STR	R3,[R0]
	LDR	R0,=AMTON	;AMTON - konstante za AM	
	LDR	R1,[R0]
	LDR	R3,=TPREKIN
	LDR	R4,=73301	;(2^40)/15MHz
	MUL	R2,R3,R4
	MOV	R2,R2,LSR#8
	MUL	R3,R1,R2
	LDR	R0,=AMINC	;AM tonska kontanta
	STR	R3,[R0]
	LDR	R0,=AMGLO	;AMGLO
	LDR	R1,[R0]
	LDR	R2,=536870	;(2^30)/2000 zaokrozeno navzdol
	MUL	R3,R1,R2
	LDR	R0,=AMMOD	;AM globina
	STR	R3,[R0]
	LDR	R3,=TPREKIN	;konstante za VOR
	LDR	R4,=73301	;(2^40)/15MHz
	MUL	R2,R3,R4
	MOV	R2,R2,LSR#8
	LDR	R1,=30		;oscilator 30Hz
	MUL	R3,R2,R1
	LDR	R0,=INC30
	STR	R3,[R0]
	LDR	R1,=960		;koleb podnosilca 2*480Hz
	MUL	R3,R2,R1
	LDR	R0,=VORDEV
	STR	R3,[R0]
	LDR	R1,=9960	;oscilator 9960Hz
	MUL	R3,R2,R1
	LDR	R0,=INC9960
	STR	R3,[R0]
	LDR	R0,=RADIAL	;RADIAL
	LDR	R1,[R0]
	LDR	R2,=1193047	;(2^32)/3600
	MUL	R3,R1,R2
	LDR	R0,=PHI30	;VOR faza
	STR	R3,[R0]
	LDR	R0,=VORGLO	;VORGLO
	LDR	R1,[R0]
	LDR	R2,=268435	;(2^30)/4000 zaokrozeno navzdol
	MUL	R3,R1,R2
	LDR	R0,=VORMOD	;VOR globina
	STR	R3,[R0]
	LDR	R0,=ILSGLO	;150Hz: ILSGLO-ILSDDM - konstante za ILS
	LDR	R1,[R0]
	LDR	R0,=ILSDDM
	LDR	R2,[R0]
	SUB	R1,R1,R2
	LDR	R2,=268435	;(2^30)/4000 zaokrozeno navzdol
	MUL	R3,R1,R2
	LDR	R0,=GLO150	;globina 150Hz
	STR	R3,[R0]
	LDR	R0,=ILSGLO	;90Hz: ILSGLO+ILSDDM
	LDR	R1,[R0]
	LDR	R0,=ILSDDM
	LDR	R2,[R0]
	ADD	R1,R1,R2
	LDR	R2,=268435	;(2^30)/4000 zaokrozeno navzdol
	MUL	R3,R1,R2
	LDR	R0,=GLO90	;globina 90Hz
	STR	R3,[R0]
	LDR	PC,[SP],#4	;povratek na link
	LTORG

;*** Vkljuci prekinitve IRQ v ARM *** (R0)
IRQON	MRS	R0,CPSR		;preberi CPSR
	BIC	R0,R0,#0x01	;preklopi v nacin IRQ
	MSR	CPSR_c,R0	;popravi CPSR
	LDR	SP,=ISKLAD	;inicializiraj IRQ SP
	MRS	R0,CPSR		;preberi CPSR
	ORR	R0,R0,#0x03	;preklopi v nacin supervisor
	BIC	R0,R0,#0x80	;vkljuci prekinitve IRQ
	MSR	CPSR_c,R0	;popravi CPSR
	BX	LR

;*** Izkljuci prekinitve IRQ v ARM *** (R0)
IRQOFF	MRS	R0,CPSR		;preberi CPSR
	ORR	R0,R0,#0x80	;izkljuci prekinitve IRQ
	MSR	CPSR_c,R0	;popravi CPSR
	BX	LR

;*** Nastavi prekinitve TIMER0 v LPC2138/2148 (PCLK=15MHz) *** (R0,R1)
TIMER0	LDR	R0,=0xE0004018	;T0MR0=TPREKIN-1 frekvenca PCLK/TPREKIN
	LDR	R1,=TPREKIN
	SUB	R1,R1,#1
	STR	R1,[R0]
	LDR	R0,=0xE0004014	;T0MCR=0x0003 reset in int iz MR0
	MOV	R1,#0x0003
	STR	R1,[R0]
	LDR	R0,=0xFFFFF010	;VICIntEnable=0x00000010 TIMER0
	LDR	R1,=0x00000010
	STR	R1,[R0]
	LDR	R0,=0xE0004004	;T0TCR=0x01 vklop TIMER0
	MOV	R1,#0x01
	STR	R1,[R0]
	BX	LR
	LTORG

;*** Sinusna tabela dolzine 2048 *** (R0-10)
SINTAB	LDR	R0,=TNASLOV	;zapolni tabelo z enotnimi zasuki
	MOV	R1,#512
SINTAB1	LDR	R2,=0x7FFFFFFF	
	STR	R2,[R0],#4
	LDR	R2,=0x00000000
	STR	R2,[R0],#4
	SUBS	R1,R1,#1
	BNE	SINTAB1
	MOV	R2,#0x00000000	;cos(fi)/2 zacetek pi/2
	MOV	R3,#0x80000000	;sin(fi)/2
	MOV	R10,#0
SINTAB2	MOV	R4,#0x80000000	;1/2+cos(fi)/2
	ADD	R4,R4,R2
	MOV	R5,#0x80000000	;R2 koren iz R4
	MOV	R2,#0
SINTAB3	ADD	R2,R2,R5
	UMULL	R6,R7,R2,R2	;R6 izgubljen
	CMP	R4,R7
	SUBCC	R2,R2,R5
	MOVS	R5,R5,LSR#1
	BNE	SINTAB3
	MOV	R5,#0x80000000	;sin(fi)/2/cos(fi/2) R4=R3/R2
	MOV	R4,#0
SINTAB4	ADD	R4,R4,R5
	UMULL	R6,R7,R2,R4	;R6 izgubljen
	CMP	R3,R7
	SUBCC	R4,R4,R5
	MOVS	R5,R5,LSR#1
	BNE	SINTAB4
	MOV	R2,R2,LSR#1	;cos(fi/2)/2 v R2
	MOV	R3,R4,LSR#1	;sin(fi/2)/2 v R3
	LDR	R8,=TNASLOV	;dodajaj zasuke v tabelo dolzine 512
	MOV	R9,#0
SINTAB5	LDR	R0,[R8]
	LDR	R1,[R8,#4]
	MOV	R4,#0x100
	MOV	R4,R4,LSR R10
	ANDS	R4,R4,R9
	BEQ	SINTAB6
	ADD	R4,R0,R0	;Re*2 v R4
	ADD	R5,R1,R1	;Im*2 v R5	
	UMULL	R7,R0,R4,R2	;Re*cos(fi) v R0, izguba v R7
	UMULL	R7,R1,R5,R2	;Im*cos(fi) v R0, izguba v R7
	UMULL	R7,R6,R4,R3	;Re*sin(fi) v R6, izguba v R7
	ADD	R1,R1,R6	;noviIm=Im*cos(fi)+Re*sin(fi) v R1
	UMULL	R7,R6,R5,R3	;Im*sin(fi) v R6, izguba v R7
	SUB	R0,R0,R6	;noviRe=Re*cos(fi)-Im*sin(fi) v R0
SINTAB6	STR	R0,[R8],#4
	STR	R1,[R8],#4
	ADD	R9,R9,#1	;zanka po tabeli
	CMP	R9,#512
	BCC	SINTAB5
	ADD	R10,R10,#1	;zanka po fi
	CMP	R10,#9
	BCC	SINTAB2
	LDR	R0,=TNASLOV	;prepisi sinus 0...PI/2
	ADD	R0,R0,#4
	LDR	R1,=SNASLOV
	MOV	R2,#512
SINTAB7	LDR	R3,[R0],#8
	STR	R3,[R1],#4
	SUBS	R2,R2,#1
	BNE	SINTAB7
	LDR	R0,=TNASLOV	;prepisi kosinus PI/2...PI
	MOV	R2,#512
SINTAB8	LDR	R3,[R0],#8
	STR	R3,[R1],#4
	SUBS	R2,R2,#1
	BNE	SINTAB8
	LDR	R0,=SNASLOV	;prepisi negativno PI...2*PI
	MOV	R2,#1024
SINTAB9 LDR	R3,[R0],#4
	RSB	R3,R3,#0
	STR	R3,[R1],#4
	SUBS	R2,R2,#1
	BNE	SINTAB9
	BX	LR
	LTORG

;*** Inicializiraj MAM v LPC2138/2148 *** (R0,R1)
MAM	LDR	R0,=0xE01FC000	;MAMCR=0
	MOV	R1,#0
	STRB	R1,[R0]
	LDR	R0,=0xE01FC004	;MAMTIM=3
	MOV	R1,#3
	STRB	R1,[R0]
	LDR	R0,=0xE01FC000	;MAMCR=2
	MOV	R1,#2
	STRB	R1,[R0]
	BX	LR
	LTORG

;*** Inicializiraj PLL0 v LPC2138/2148 *** (R0,R1,R2)
PLL0	LDR	R0,=0xE01FC084	;PLL0CFG=0x24 P=2,M=5
	MOV	R1,#0x24
	STRB	R1,[R0]
	LDR	R0,=0xE01FC080	;PLL0CON=0x01 PLL-enable
	MOV	R1,#0x01
	STRB	R1,[R0]
	LDR	R0,=0xE01FC08C	;PLL0FEED
	MOV	R1,#0xAA
	MOV	R2,#0x55
	STRB	R1,[R0]
	STRB	R2,[R0]
PLL01	LDR	R0,=0xE01FC088	;PLL0STAT cakanje uklenitve
	LDR	R1,[R0]
	ANDS	R1,R1,#0x400
	BEQ	PLL01
	LDR	R0,=0xE01FC080	;PLL0CON=0x03 PLL-enable&connect
	MOV	R1,#0x03
	STRB	R1,[R0]
	LDR	R0,=0xE01FC08C	;PLL0FEED
	MOV	R1,#0xAA
	MOV	R2,#0x55
	STRB	R1,[R0]
	STRB	R2,[R0]
	BX	LR
	LTORG

;*** Inicializiraj GPIO v LPC2138/2148 *** (R0,R1)
GPIO	LDR	R0,=0xE002C000	;PINSEL0 P0.8-9=TXD-RXD(UART1)
	LDR	R1,=0x00050000
	STR	R1,[R0]
	LDR	R0,=0xE002C004	;PINSEL1 P0.25=Aout(DAC)
	LDR	R1,=0x00080000
	STR	R1,[R0]
	LDR	R0,=0xE01FC1A0	;SCS=0x03 high-speed GPIO 0&1
	MOV	R1,#0x03
	STR	R1,[R0]
	LDR	R0,=0x3FFFC000	;FIO0DIR izhodi 0.0-0.13 0.15-0.31
	LDR	R1,=0xFFFFBFFF
	STR	R1,[R0]
	BX	LR
	LTORG

;*** Postavi frekvenco DDS iz R8 *** (R0,R1,R2,R3,R8)
FRQDDS	LDR	R0,=0x3FFFC01E	;FIO0CLR2
	LDR	R1,=0x3FFFC01A	;FIO0SET2
	MOV	R2,#0x02	;taktni impulz /W_CLK
	MOV	R3,#0x08	;D7 SET/RESET
	MOVS	R8,R8,RRX
	STRBCC	R3,[R0]	;W0 LSB
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W1
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W2
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W3
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W4
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W5
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W6
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W7
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W8
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W9
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W10
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W11
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W12
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W13
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W14
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W15
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W16
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W17
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W18
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W19
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W20
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W21
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W22
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W23
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W24
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W25
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W26
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W27
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W28
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W29
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W30
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRBCC	R3,[R0]	;W31 MSB
	STRBCS	R3,[R1]
	MOVS	R8,R8,RRX
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRB	R3,[R1]	;W32 1=6XREFCLK
	NOP
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRB	R3,[R0]	;W33 0=TESTMODE
	NOP
	STRB	R2,[R0]
	STRB	R2,[R1]
	STRB	R2,[R0]	;W34 0=POWERDOWN
	STRB	R2,[R1]
	STRB	R2,[R0]	;W35 00000
	STRB	R2,[R1]
	STRB	R2,[R0]	;W36
	STRB	R2,[R1]
	STRB	R2,[R0]	;W37
	STRB	R2,[R1]
	STRB	R2,[R0]	;W38
	STRB	R2,[R1]
	STRB	R2,[R0]	;W39
	STRB	R2,[R1]
	MOV	R3,#0x04	;taktni impulz /FQ_UD
	STRB	R3,[R0]
	STRB	R3,[R1]
	BX	LR
	LTORG

;*** Inicializacija AD9851 *** (R0,R1,R2,R3,R8)
INIDDS	LDR	R0,=0x3FFFC016	;FIO0PIN2
	MOV	R1,#0x06	;0=/RESET 0=D7 1=/FQ_UD 1=/W_CLK
	STRB	R1,[R0]
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	MOV	R1,#0x16	;1=/RESET 0=D7 1=/FQ_UD 1=/W_CLK
	STRB	R1,[R0]
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	LDR	R0,=0x3FFFC01E	;FIO0CLR2
	LDR	R1,=0x3FFFC01A	;FIO0SET2
	MOV	R2,#0x02	;taktni impulz /W_CLK
	STRB	R2,[R0]
	STRB	R2,[R1]
	MOV	R3,#0x04	;taktni impulz /FQ_UD
	STRB	R3,[R0]
	STRB	R3,[R1]
	LDR	R8,=0x0E38E38E	;zacetna frekvenca
	B	FRQDDS
	LTORG

;*** Inicializacija HD44780 *** (R0,R1,R2,R3)
INILCD	STR	LR,[SP,#-4]!	;resi link
	BL	T4MS
	MOV	R0,#0x38	;function set 
	BL	UKAZ
	BL	T4MS
	MOV	R0,#0x38	;function set
	BL	UKAZ
	MOV	R0,#0x38	;function set
	BL	UKAZ
	MOV	R0,#0x08	;display off
	BL	UKAZ
	MOV	R0,#0x01	;display clear
	BL	UKAZ
	BL	T4MS
	MOV	R0,#0x06	;entry mode set
	BL	UKAZ
	MOV	R0,#0x0C	;display on
	BL	UKAZ
	MOV	R0,#0x40	;set CGRAM address
	BL	UKAZ
	MOV	R0,#0x15	;znak 0 - sahovnica za kurzor
	BL	ZNAK
	MOV	R0,#0x0A
	BL	ZNAK
	MOV	R0,#0x15
	BL	ZNAK
	MOV	R0,#0x0A
	BL	ZNAK
	MOV	R0,#0x15
	BL	ZNAK
	MOV	R0,#0x0A
	BL	ZNAK
	MOV	R0,#0x15
	BL	ZNAK
	MOV	R0,#0x00
	BL	ZNAK
	MOV	R0,#0x08	;znak 1 - plusminus
	BL	ZNAK
	MOV	R0,#0x1C
	BL	ZNAK
	MOV	R0,#0x09
	BL	ZNAK
	MOV	R0,#0x02
	BL	ZNAK
	MOV	R0,#0x04
	BL	ZNAK
	MOV	R0,#0x08
	BL	ZNAK
	MOV	R0,#0x17
	BL	ZNAK
	MOV	R0,#0x00
	BL	ZNAK
	MOV	R0,#0x0C	;znak 2 - stopinja
	BL	ZNAK
	MOV	R0,#0x12
	BL	ZNAK
	MOV	R0,#0x12
	BL	ZNAK
	MOV	R0,#0x0C
	BL	ZNAK
	MOV	R0,#0x00
	BL	ZNAK
	MOV	R0,#0x00
	BL	ZNAK
	MOV	R0,#0x00
	BL	ZNAK
	MOV	R0,#0x00
	BL	ZNAK
	LDR	PC,[SP],#4	;povratek na link

;*** Izpisi inacico programa *** (R0,R1,R2,R3)
INACICA	STR	LR,[SP,#-4]!	;resi link
	MOV	R0,#0x80	;set DDRAM address - zacetek prve vrstice
	BL	UKAZ
	MOV	R0,#0x44	;"D" - DDS RF GENERATOR
	BL	ZNAK
	MOV	R0,#0X44	;"D"
	BL	ZNAK
	MOV	R0,#0x53	;"S"
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x52	;"R"
	BL	ZNAK
	MOV	R0,#0x46	;"F"
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x47	;"G"
	BL	ZNAK
	MOV	R0,#0x45	;"E"
	BL	ZNAK
	MOV	R0,#0x4E	;"N"
	BL	ZNAK
	MOV	R0,#0x45	;"E"
	BL	ZNAK
	MOV	R0,#0x52	;"R"
	BL	ZNAK
	MOV	R0,#0x41	;"A"
	BL	ZNAK
	MOV	R0,#0x54	;"T"
	BL	ZNAK
	MOV	R0,#0x4F	;"O"
	BL	ZNAK
	MOV	R0,#0x52	;"R"
	BL	ZNAK
	MOV	R0,#0xC0	;set DDRAM address - zacetek druge vrstice
	BL	UKAZ
	MOV	R0,#0x53	;"S" - S53MV
	BL	ZNAK
	MOV	R0,#0x35	;"5"
	BL	ZNAK
	MOV	R0,#0x33	;"3"
	BL	ZNAK
	MOV	R0,#0x4D	;"M"
	BL	ZNAK
	MOV	R0,#0x56	;"V"
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x32	;"2" - 20.07.2008
	BL	ZNAK
	MOV	R0,#0x30	;"0"
	BL	ZNAK
	MOV	R0,#0x2E	;"."
	BL	ZNAK
	MOV	R0,#0x30	;"0"
	BL	ZNAK
	MOV	R0,#0x37	;"7"
	BL	ZNAK
	MOV	R0,#0x2E	;"."
	BL	ZNAK
	MOV	R0,#0x32	;"2"
	BL	ZNAK
	MOV	R0,#0x30	;"0"
	BL	ZNAK
	MOV	R0,#0x30	;"0"
	BL	ZNAK
	MOV	R0,#0x38	;"8"
	BL	ZNAK
	LDR	PC,[SP],#4	;povratek na link

;*** Izpisi vsebino pomnilnika 2x16 znakov *** (R0,R1,R2,R3,R4)
IZPIS	STR	LR,[SP,#-4]!	;resi link
	LDR	R3,=ZASLON
	LDR	R0,=ZNACKA	;utripajoca znacka
	LDR	R4,[R0]
	LDR	R0,=UTRIP
	LDR	R1,[R0]
	ADD	R1,R1,#1
	STR	R1,[R0]
	ANDS	R1,R1,#ZMIGA
	MOVEQ	R4,#0
	MOV	R0,#0x80	;set DDRAM address - zacetek prve vrstice
	BL	UKAZ
	MOV	R2,#16
IZPIS1	LDRB	R0,[R3],#1
	SUBS	R4,R4,#1
	MOVEQ	R0,#0x00
	BL	ZNAK
	SUBS	R2,R2,#1
	BNE	IZPIS1
	MOV	R0,#0xC0	;set DDRAM address - zacetek druge vrstice
	BL	UKAZ
	MOV	R2,#16
IZPIS2	LDRB	R0,[R3],#1
	SUBS	R4,R4,#1
	MOVEQ	R0,#0x00
	BL	ZNAK
	SUBS	R2,R2,#1
	BNE	IZPIS2
	LDR	PC,[SP],#4	;povratek na link
	LTORG

;*** Znak iz R0 v HD44780 *** (R0,R1)
ZNAK	STR	LR,[SP,#-4]!	;resi link
	LDR	R1,=0x3FFFC014	;FIO0PIN3 podatek in RS=1
	STRB	R0,[R1]
	LDR	R1,=0x3FFFC017	;FIO0PIN3
	MOV	R0,#0x20
	STRB	R0,[R1]
	BL	T1US
	MOV	R0,#0x60	;vklopi E
	STRB	R0,[R1]
	BL	T1US
	MOV	R0,#0x20	;izkolpi E
	STRB	R0,[R1]
	BL	T100US
	LDR	PC,[SP],#4	;povratek na link
	LTORG

;*** Ukaz iz R0 v HD44780 *** (R0,R1)
UKAZ	STR	LR,[SP,#-4]!	;resi link
	LDR	R1,=0x3FFFC014	;FIO0PIN0 podatek in RS=0
	STRB	R0,[R1]
	LDR	R1,=0x3FFFC017	;FIO0PIN3
	MOV	R0,#0x00
	STRB	R0,[R1]
	BL	T1US
	MOV	R0,#0x40	;vklopi E
	STRB	R0,[R1]
	BL	T1US
	MOV	R0,#0x00	;izkolpi E
	STRB	R0,[R1]
	BL	T100US
	LDR	PC,[SP],#4	;povratek na link
	LTORG

;*** Zakasnitev 1us *** (R0)
T1US	MOV	R0,#15
T1US1	SUBS	R0,R0,#1
	BPL	T1US1
	BX	LR

;*** Zakasnitev 100us *** (R0,R1)
T100US	STR	LR,[SP,#-4]!	;resi link
	MOV	R1,#100
T100US1	BL	T1US
	SUBS	R1,R1,#1
	BPL	T100US1
	LDR	PC,[SP],#4	;povratek na link

;*** Zakasnitev 4ms *** (R0,R1,R2)
T4MS	STR	LR,[SP,#-4]!	;resi link
	MOV	R2,#40
T4MS1	BL	T100US
	SUBS	R2,R2,#1
	BPL	T4MS1
	LDR	PC,[SP],#4	;povratek na link

;*** Zakasnitev 1s *** (R0,R1,R2,R3)
T1S	STR	LR,[SP,#-4]!	;resi link
	MOV	R3,#250
T1S1	BL	T4MS
	SUBS	R3,R3,#1
	BPL	T1S1
	LDR	PC,[SP],#4	;povratek na link

;*** Desetisko deljenje R0 z ostankom R1 v ASCII *** (R0,R1,R2,R3)
DESET	MOV	R1,#0
	MOV	R2,#0
	MOV	R3,#32
DESET1	ADDS	R0,R0,R0
	ADC	R1,R1,R1
	ADD	R2,R2,R2
	CMP	R1,#10
	ADDCS	R2,R2,#1
	SUBCS	R1,R1,#10
	SUBS	R3,R3,#1
	BNE	DESET1
	MOV	R0,R2
	ADD	R1,R1,#0x30
	BX	LR

;*** Brisi R0 vodilnih nicel v [R8]+ *** (R0,R1,R8)
BRISI	LDRB	R1,[R8]
	CMP	R1,#0x30
	BNE	BRISI1
	MOV	R1,#0x20
	STRB	R1,[R8],#1
	SUBS	R0,R0,#1
	BNE	BRISI
BRISI1	ADD	R8,R8,R0
	BX	LR

;*** Predznaceni decimalni izpis R0 v [R8]+ v obliki 2+1 *** (R0,R1,R2,R3,R8)
DECP21	STR	LR,[SP,#-4]!	;resi link
	MOV	R1,#0x2B	;"+"
	MOVS	R0,R0
	MOVMI	R1,#0x2D	;"-"
	RSBMI	R0,R0,#0
	STRB	R1,[R8]
	BL	DESET
	STRB	R1,[R8,#4]!
	MOV	R1,#0x2E	;"."
	STRB	R1,[R8,#-1]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	CMP	R1,#0x30	;brisi niclo desetic, premakni predznak?
	LDRB	R1,[R8,#-1]
	STRBEQ	R1,[R8]
	MOV	R1,#0x20
	STRBEQ	R1,[R8,#-1]
	ADD	R8,R8,#4
	LDR	PC,[SP],#4	;povratek na link

;*** Decimalni izpis R0 v [R8]+ v obliki 4+0 *** (R0,R1,R2,R3,R8)
DEC40	STR	LR,[SP,#-4]!	;resi link
	BL	DESET
	STRB	R1,[R8,#3]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	BL	DESET
	MOV	R0,#3
	BL	BRISI
	ADD	R8,R8,#1
	LDR	PC,[SP],#4	;povratek na link

;*** Decimalni izpis R0 v [R8]+ v obliki 3+1 *** (R0,R1,R2,R3,R8)
DEC31	STR	LR,[SP,#-4]!	;resi link
	BL	DESET
	STRB	R1,[R8,#4]!
	MOV	R1,#0x2E	;"."
	STRB	R1,[R8,#-1]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	MOV	R0,#2
	BL	BRISI
	ADD	R8,R8,#3
	LDR	PC,[SP],#4	;povratek na link

;*** Decimalni izpis R0 v [R8]+ v obliki 3+5 *** (R0,R1,R2,R3,R8)
DEC35	STR	LR,[SP,#-4]!	;resi link
	BL	DESET
	STRB	R1,[R8,#8]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	MOV	R1,#0x2E	;"."
	STRB	R1,[R8,#-1]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	BL	DESET
	STRB	R1,[R8,#-1]!
	MOV	R0,#2
	BL	BRISI
	ADD	R8,R8,#7
	LDR	PC,[SP],#4	;povratek na link

;*** Preberi ukaz s tipk *** (R0,R1,R2,R3,R4)
TIPKE	LDR	R0,=0x3FFFC036	;FIO1PIN2 precita tipke v R1
	LDRB	R1,[R0]
	AND	R1,R1,#0x0F
	LDR	R0,=TIPKES	;stara vrednost tipk v R2
	LDR	R2,[R0]
	STR	R1,[R0]
	EOR	R1,R1,#0x0F
	AND	R2,R2,R1	;veljavne zastavice v R2
	LDR	R0,=UTRIP	;sahovnica ali znak?
	LDR	R3,[R0]
	LDR	R1,=KAZALO	;KAZALO	LEVO/DESNO
	LDR	R4,[R1]
	TST	R2,#0x08	;ukaz LEVO in sahovnica?
	MOVNE	R3,#ZMIGA
	SUBNE	R4,R4,#1
	TST	R2,#0x01	;ukaz DESNO in sahovnica?
	MOVNE	R3,#ZMIGA
	ADDNE	R4,R4,#1
	STR	R4,[R1]		;shrani KAZALO
	MOV	R4,#0
	TST	R2,#0x04	;ukaz GOR in znak?
	ADDNE	R4,R4,#1
	MOVNE	R3,#0
	TST	R2,#0x02	;ukaz DOL in znak?
	SUBNE	R4,R4,#1
	MOVNE	R3,#0
	LDR	R1,=PREMIK	;shrani PREMIK
	STR	R4,[R1]
	STR	R3,[R0]		;shrani sahovnico/znak
	BX	LR
	LTORG

;*** Izvedi ukaz s tipk *** (R0,R1,R2,R3)
IZVEDI	LDR	R1,=NACIN	;preveri NACIN
	LDR	R0,[R1]
	MOVS	R0,R0
	MOVMI	R0,#0
	CMP	R0,#5
	MOVCS	R0,#5
	STR	R0,[R1]
	MOV	R2,#12		;gornja meja za KAZALO
	MOVS	R0,R0
	MOVNE	R2,#16
	CMP	R0,#5
	MOVEQ	R2,#8
	LDR	R1,=KAZALO	;preveri KAZALO
	LDR	R0,[R1]
	MOVS	R0,R0
	MOVMI	R0,#0
	CMP	R0,R2
	MOVCS	R0,R2
	STR	R0,[R1]
	MOVS	R1,R0		;nastavljanje NACIN?
	BNE	IZVEDI1
	LDR	R1,=ZNACKA
	MOV	R0,#0
	STR	R0,[R1]
	LDR	R1,=PREMIK
	LDR	R2,[R1]
	LDR	R1,=NACIN
	LDR	R0,[R1]
	ADD	R0,R0,R2
	MOVS	R0,R0		;preveri NACIN
	MOVMI	R0,#0
	CMP	R0,#5
	MOVCS	R0,#5
	STR	R0,[R1]
	BX	LR
IZVEDI1	SUBS	R1,R1,#8	;nastavljanje FREQ?
	BHI	IZVEDI2
	LDR	R0,=ZNACKA
	ADD	R2,R1,#12
	CMP	R2,#8
	ADDCS	R2,R2,#1
	STR	R2,[R0]
	MOV	R0,#1		;posci korak nastavljanja
	ADDS	R1,R1,#1
	MOVEQ	R0,#10
	ADDS	R1,R1,#1
	MOVEQ	R0,#100
	ADDS	R1,R1,#1
	LDREQ	R0,=1000
	ADDS	R1,R1,#1
	LDREQ	R0,=10000
	ADDS	R1,R1,#1
	LDREQ	R0,=100000
	ADDS	R1,R1,#1
	LDREQ	R0,=1000000
	ADDS	R1,R1,#1
	LDREQ	R0,=10000000
	LDR	R1,=PREMIK	;smer premika
	LDR	R2,[R1]
	MOVS	R2,R2
	BXEQ	LR
	RSBMI	R0,R0,#0
	LDR	R1,=NACIN
	LDR	R2,[R1]
	LDR	R1,=FREQ	;popravi FREQ
	CMP	R2,#5
	LDREQ	R1,=DDSCLK	;popravi DDSCLK v NACIN=5
	LDR	R2,[R1]
	ADD	R2,R2,R0
	STR	R2,[R1]
	BX	LR
IZVEDI2	LDR	R0,=NACIN	;NACIN v R3
	LDR	R3,[R0]
	MOV	R4,#31
	CMP	R3,#3
	MOVCS	R4,#30
	LDR	R0,=ZNACKA	;zmiganje v drugi vrsti
	ADD	R2,R1,#16
	CMP	R2,#20
	ADDCS	R2,#1
	CMP	R2,#22
	ADDCS	R2,#5
	CMP	R2,R4
	ADDCS	R2,#1
	STR	R2,[R0]
	SUB	R2,R1,#1	;posci korak nastavljanja
	AND	R2,R2,#0x03
	MOV	R0,#1000
	SUBS	R2,R2,#1
	MOVEQ	R0,#100
	SUBS	R2,R2,#1
	MOVEQ	R0,#10
	SUBS	R2,R2,#1
	LDREQ	R0,=1
	LDR	R4,=PREMIK	;smer premika
	LDR	R2,[R4]
	MOVS	R2,R2
	BXEQ	LR
	RSBMI	R0,R0,#0
	SUB	R1,R1,#1	;poisci parameter
	MOV	R1,R1,LSR#2
	ADD	R1,R1,R3,LSL#1
	LDR	R3,=CWJAK
	SUBS	R1,R1,#2
	LDREQ	R3,=KOLEB
	SUBS	R1,R1,#1
	LDREQ	R3,=FMTON
	SUBS	R1,R1,#1
	LDREQ	R3,=AMGLO
	SUBS	R1,R1,#1
	LDREQ	R3,=AMTON
	SUBS	R1,R1,#1
	LDREQ	R3,=RADIAL
	SUBS	R1,R1,#1
	LDREQ	R3,=VORGLO
	SUBS	R1,R1,#1
	LDREQ	R3,=ILSDDM
	SUBS	R1,R1,#1
	LDREQ	R3,=ILSGLO
	LDR	R2,[R3]		;popravi izbrani parameter
	ADD	R2,R2,R0
	STR	R2,[R3]
	BX	LR
	LTORG

;*** Izpisi menu na zaslon *** (R0,R1,R2,R3,R8)
MENU	STR	LR,[SP,#-4]!	;resi link
	LDR	R8,=ZASLON
	LDR	R0,=NACIN	;izpis nacina delovanja
	LDR	R1,[R0]
	MOVS	R1,R1
	BNE	MENU1
	MOV	R0,#0x43	;nacin 0 = "CW "
	STRB	R0,[R8],#1
	MOV	R0,#0x57
	STRB	R0,[R8],#1
	MOV	R0,#0x20
	STRB	R0,[R8],#1
	B	MENU0
MENU1	SUBS	R1,R1,#1
	BNE	MENU2
	MOV	R0,#0x46	;nacin 1 = "FM "
	STRB	R0,[R8],#1
	MOV	R0,#0x4D
	STRB	R0,[R8],#1
	MOV	R0,#0x20
	STRB	R0,[R8],#1
	B	MENU0
MENU2	SUBS	R1,R1,#1
	BNE	MENU3
	MOV	R0,#0x41	;nacin 2 = "AM "
	STRB	R0,[R8],#1
	MOV	R0,#0x4D
	STRB	R0,[R8],#1
	MOV	R0,#0x20
	STRB	R0,[R8],#1
	B	MENU0
MENU3	SUBS	R1,R1,#1
	BNE	MENU4
	MOV	R0,#0x56	;nacin 3 = "VOR"
	STRB	R0,[R8],#1
	MOV	R0,#0x4F
	STRB	R0,[R8],#1
	MOV	R0,#0x52
	STRB	R0,[R8],#1
	B	MENU0
MENU4	SUBS	R1,R1,#1
	BNE	MENU5
	MOV	R0,#0x49	;nacin 4 = "ILS"
	STRB	R0,[R8],#1
	MOV	R0,#0x4C
	STRB	R0,[R8],#1
	MOV	R0,#0x53
	STRB	R0,[R8],#1
	B	MENU0
MENU5	MOV	R0,#0x52	;nacin 5 = "REF"
	STRB	R0,[R8],#1
	MOV	R0,#0x45
	STRB	R0,[R8],#1
	MOV	R0,#0x46
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	LDR	R1,=DDSCLK	;preveri takt DDSja
	LDR	R0,[R1]
	LDR	R2,=99999999
	MOVS	R0,R0
	MOVMI	R0,#0
	CMP	R2,R0
	MOVCC	R0,R2
	STR	R0,[R1]	
	BL	DEC35		;izpisi takt DDSja
	MOV	R0,#0x4D	;"M"
	STRB	R0,[R8],#1
	MOV	R0,#0x48	;"H"
	STRB	R0,[R8],#1
	MOV	R0,#0x7A	;"z"
	STRB	R0,[R8],#1
	LDR	R1,=CWJAK	;izpisi jakost CW
	LDR	R0,[R1]	
	BL	DEC31
	MOV	R0,#0x25	;"%"
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	LDR	R1,=FREQ	;izpisi frekvenco
	LDR	R0,[R1]
	BL	DEC35
	LDR	PC,[SP],#4	;povratek na link
	LTORG
MENU0	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	LDR	R1,=FREQ	;preveri frekvenco
	LDR	R0,[R1]
	LDR	R2,=99999999
	MOVS	R0,R0
	MOVMI	R0,#0
	CMP	R2,R0
	MOVCC	R0,R2
	STR	R0,[R1]	
	BL	DEC35		;izpisi frekvenco
	MOV	R0,#0x4D	;"M"
	STRB	R0,[R8],#1
	MOV	R0,#0x48	;"H"
	STRB	R0,[R8],#1
	MOV	R0,#0x7A	;"z"
	STRB	R0,[R8],#1
	LDR	R1,=NACIN	;druga vrstica glede na nacin
	LDR	R0,[R1]
	MOVS	R0,R0
	BNE	MENU6
	LDR	R1,=CWJAK	;preveri jakost CW
	LDR	R0,[R1]
	LDR	R2,=2000
	MOVS	R0,R0
	MOVMI	R0,#0
	CMP	R2,R0
	MOVCC	R0,R2
	STR	R0,[R1]
	BL	DEC31		;izpisi jakost CW
	MOV	R0,#0x25	;"%"
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" " - praznina v nacinu CW
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	LDR	PC,[SP],#4	;povratek na link
	LTORG
MENU6	SUBS	R0,R0,#1	;nacin FM: koleb in ton
	BNE	MENU7
	LDR	R1,=KOLEB	;preveri FM koleb
	LDR	R0,[R1]
	LDR	R2,=9999
	MOVS	R0,R0
	MOVMI	R0,#0
	CMP	R2,R0
	MOVCC	R0,R2
	STR	R0,[R1]
	BL	DEC31		;izpisi FM koleb
	MOV	R0,#1		;"plusminus"
	STRB	R0,[R8],#1
	MOV	R0,#0x6B	;"k"
	STRB	R0,[R8],#1
	MOV	R0,#0x48	;"H"
	STRB	R0,[R8],#1
	MOV	R0,#0x7A	;"z"
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	LDR	R1,=FMTON		;preveri FM ton
	LDR	R0,[R1]
	LDR	R2,=9999
	MOVS	R0,R0
	MOVMI	R0,#0
	CMP	R2,R0
	MOVCC	R0,R2
	STR	R0,[R1]
	BL	DEC40		;izpisi FM ton
	MOV	R0,#0x48	;"H"
	STRB	R0,[R8],#1
	MOV	R0,#0x7A	;"z"
	STRB	R0,[R8],#1
	LDR	PC,[SP],#4	;povratek na link
	LTORG
MENU7	SUBS	R0,R0,#1	;nacin AM: globina in ton
	BNE	MENU8
	LDR	R1,=AMGLO	;preveri AM globino
	LDR	R0,[R1]
	LDR	R2,=1000
	MOVS	R0,R0
	MOVMI	R0,#0
	CMP	R2,R0
	MOVCC	R0,R2
	STR	R0,[R1]
	BL	DEC31		;izpisi AM globino
	MOV	R0,#0x25	;"%"
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	LDR	R1,=AMTON		;preveri AM ton
	LDR	R0,[R1]
	LDR	R2,=9999
	MOVS	R0,R0
	MOVMI	R0,#0
	CMP	R2,R0
	MOVCC	R0,R2
	STR	R0,[R1]
	BL	DEC40		;izpisi AM ton
	MOV	R0,#0x48	;"H"
	STRB	R0,[R8],#1
	MOV	R0,#0x7A	;"z"
	STRB	R0,[R8],#1
	LDR	PC,[SP],#4	;povratek na link
	LTORG
MENU8	SUBS	R0,R0,#1	;nacin VOR: globina in radial
	BNE	MENU9
	LDR	R1,=RADIAL	;preveri VOR radial
	LDR	R0,[R1]
	LDR	R2,=3599
	MOVS	R0,R0
	MOVMI	R0,#0
	CMP	R2,R0
	MOVCC	R0,R2
	STR	R0,[R1]
	BL	DEC31		;izpisi VOR radial
	MOV	R0,#2		;"stopinje"
	STRB	R0,[R8],#1
	MOV	R0,#0x52	;"R"
	STRB	R0,[R8],#1
	MOV	R0,#0x41	;"A"
	STRB	R0,[R8],#1
	MOV	R0,#0x44	;"D"
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	LDR	R1,=VORGLO	;preveri 30Hz globino
	LDR	R0,[R1]
	LDR	R2,=1000
	MOVS	R0,R0
	MOVMI	R0,#0
	CMP	R2,R0
	MOVCC	R0,R2
	STR	R0,[R1]
	BL	DEC31		;izpisi 30Hz globino
	MOV	R0,#0x25	;"%"
	STRB	R0,[R8],#1
	LDR	PC,[SP],#4	;povratek na link
	LTORG
MENU9	LDR	R1,=ILSGLO	;nacin ILS: preveri abs(DDM)<ILSGLO
	LDR	R2,[R1]
	LDR	R1,=ILSDDM
	LDR	R0,[R1]
	MOVS	R3,R0		;abs(DDM)
	RSBMI	R0,R0,#0
	CMP	R2,R0
	MOVCC	R0,R2
	MOVS	R3,R3		;vrni predznak
	RSBMI	R0,R0,#0
	STR	R0,[R1]
	BL	DECP21		;izpisi DDM
	MOV	R0,#0x25	;"%"
	STRB	R0,[R8],#1
	MOV	R0,#0x44	;"D"
	STRB	R0,[R8],#1
	MOV	R0,#0x44	;"D"
	STRB	R0,[R8],#1
	MOV	R0,#0x4D	;"M"
	STRB	R0,[R8],#1
	MOV	R0,#0x20	;" "
	STRB	R0,[R8],#1
	LDR	R1,=ILSGLO	;preveri globino ILS 150Hz+90Hz
	LDR	R0,[R1]
	LDR	R2,=999
	MOVS	R0,R0
	MOVMI	R0,#0
	CMP	R2,R0
	MOVCC	R0,R2
	STR	R0,[R1]
	BL	DEC31		;izpisi globino ILS 150Hz+90Hz
	MOV	R0,#0x25	;"%"
	STRB	R0,[R8],#1
	LDR	PC,[SP],#4	;povratek na link
	LTORG

;*** Zacetek programa po resetu ***
ZACNI	LDR	SP,=SKLAD	;inicializiraj SP
	BL	MAM	;inicializiraj MAM v LPC2138/2148
	BL	GPIO	;inicializiraj GPIO v LPC2138/2148
	BL	PLL0	;inicializiraj PLL0 v LPC2138/2148
	BL	SINTAB	;sinusna tabela
	BL	INILCD	;inicializiraj LCD
	BL	INACICA ;inacica programa
	BL	T1S	;1s cakanja
	BL	TIMER0	;nastavi 50kHz prekinitve TIMER0 v LPC2138/2148
	BL	IRQON	;vkljuci prekinitve IRQ
	BL	INIDDS	;inicializiraj DDS
	BL	INIPAR	;inicializiraj parametre iz FLASH
	B	ZANKA	;glavna zanka programa
	LTORG

;*** Glavna zanka programa ***
ZANKA	BL	RACUN	;preracunaj konstante
	BL	TIPKE	;preberi ukaz s tipk
	BL	IZVEDI	;izvedi ukaz s tipk
	BL	MENU	;izpisi menu na zaslon
	BL	IZPIS	;izpisi vsebino pomnilnika 2x16 znakov
	BL	EEPROM	;vpis v FLASH pomnilnik
	B	ZANKA
	LTORG

;*** Inicializiraj parametre iz FLASH *** (R0,R1,R2,R3)
INIPAR	MOV	R0,#0		;zacetni kazalec
	LDR	R1,=KAZALO
	STR	R0,[R1]
	LDR	R0,=0x0007B000	;source Flash address
	LDR	R1,=0x40000600	;destination RAM address
	LDR	R2,=64
INIPAR1	LDR	R3,[R0],#4	;prepisi 64*4bajte
	STR	R3,[R1],#4		
	SUBS	R2,R2,#1
	BNE	INIPAR1
	BX	LR
	LTORG

;*** Vpis v FLASH pomnilnik *** (R0,R1,R2,R3,R4)
EEPROM	LDR	R0,=0x3FFFC036	;FIO1PIN2 precita tipke v R1
	LDRB	R1,[R0]
	AND	R1,R1,#0x0F	;izkljucno LEVO+DESNO vpis v EEPROM?
	EORS	R1,R1,#0x06
	BXNE	LR
	LDR	R0,=0x0007B000	;Flash address
	LDR	R1,=0x40000600	;RAM address
	LDR	R2,=64
EEPROM1	LDR	R3,[R0],#4	;primerjaj 64*4bajte
	LDR	R4,[R1],#4
	CMP	R3,R4
	BNE	EEPROM2		;vpisi EEPROM samo razlicno!
	SUBS	R2,R2,#1
	BNE	EEPROM1
	BX	LR
EEPROM2	STR	LR,[SP,#-4]!	;resi link
	BL	IRQOFF		;izkljuci prekinitve IRQ
	BL	EELCD		;napis na LCD
	LDR	R0,=IAPCMD	;prepare sector 25: 0x0007B000-0x0007BFFF
	LDR	R2,=50		;command code 50
	STR	R2,[R0]
	LDR	R2,=25		;start sector number 25
	STR	R2,[R0,#4]
	LDR	R2,=25		;end sector number 25
	STR	R2,[R0,#8]
	LDR	R1,=IAPRES
	LDR	R2,=0x7FFFFFF1	;IAP naslov 0x7ffffff1 THUMB
	MOV	LR,PC
	BX	R2
	BL	T4MS		;zakasnitev 4ms
	LDR	R0,=IAPCMD	;erase sector 25: 0x0007B000-0x0007BFFF
	LDR	R2,=52		;command code 50
	STR	R2,[R0]
	LDR	R2,=25		;start sector number 25
	STR	R2,[R0,#4]
	LDR	R2,=25		;end sector number 25
	STR	R2,[R0,#8]
	LDR	R2,=60000	;system clock frequency (CCLK) in kHz
	STR	R2,[R0,#12]
	LDR	R1,=IAPRES
	LDR	R2,=0x7FFFFFF1	;IAP naslov 0x7ffffff1 THUMB
	MOV	LR,PC
	BX	R2
	BL	T4MS		;zakasnitev 4ms
	LDR	R0,=IAPCMD	;prepare sector 25: 0x0007B000-0x0007BFFF
	LDR	R2,=50		;command code 50
	STR	R2,[R0]
	LDR	R2,=25		;start sector number 25
	STR	R2,[R0,#4]
	LDR	R2,=25		;end sector number 25
	STR	R2,[R0,#8]
	LDR	R1,=IAPRES
	LDR	R2,=0x7FFFFFF1	;IAP naslov 0x7ffffff1 THUMB
	MOV	LR,PC
	BX	R2
	BL	T4MS		;zakasnitev 4ms
	LDR	R0,=IAPCMD	;copy RAM to Flash: 0x40000600>0x0007B000
	LDR	R2,=51		;command code 51
	STR	R2,[R0]
	LDR	R2,=0x0007B000	;destination Flash address
	STR	R2,[R0,#4]
	LDR	R2,=0x40000600	;source RAM address
	STR	R2,[R0,#8]
	LDR	R2,=256		;number of bytes to be written (256)
	STR	R2,[R0,#12]
	LDR	R2,=60000	;system clock frequency (CCLK) in kHz
	STR	R2,[R0,#16]
	LDR	R1,=IAPRES
	LDR	R2,=0x7FFFFFF1	;IAP naslov 0x7ffffff1 THUMB
	MOV	LR,PC
	BX	R2
	BL	T1S		;zakasnitev 1s
	BL	INIPAR		;inicializiraj parametre iz FLASH
	BL	IRQON		;vkljuci prekinitve IRQ
	LDR	PC,[SP],#4	;povratek na link
	LTORG

;*** Izpisi vpis v EEPROM *** (R0,R1,R2,R3)
EELCD	STR	LR,[SP,#-4]!	;resi link
	MOV	R0,#0x80	;set DDRAM address - zacetek prve vrstice
	BL	UKAZ
	MOV	R0,#0x2A	;"*" - ***  EEPROM  ***
	BL	ZNAK
	MOV	R0,#0X2A	;"*"
	BL	ZNAK
	MOV	R0,#0x2A	;"*"
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x45	;"E"
	BL	ZNAK
	MOV	R0,#0x45	;"E"
	BL	ZNAK
	MOV	R0,#0x50	;"P"
	BL	ZNAK
	MOV	R0,#0x52	;"R"
	BL	ZNAK
	MOV	R0,#0x4F	;"O"
	BL	ZNAK
	MOV	R0,#0x4D	;"M"
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x2A	;"*"
	BL	ZNAK
	MOV	R0,#0x2A	;"*"
	BL	ZNAK
	MOV	R0,#0x2A	;"*"
	BL	ZNAK
	MOV	R0,#0xC0	;set DDRAM address - zacetek druge vrstice
	BL	UKAZ
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	MOV	R0,#0x20	;" "
	BL	ZNAK
	LDR	PC,[SP],#4	;povratek na link

;*** Konec delovanja zbirnika ARM ***
	END
